<template>
  <div v-if="user">
    <div class="modal__input" :class="{ 'is-active': newItem.name.length > 0 }">
      <span class="modal__label">{{ $t('events.name') }}</span>
      <el-input @focus="inputFocus" border line v-model="newItem.name" />
    </div>

    <div
      class="modal__input"
      :class="{ 'is-active': newItem.comment.length > 0 }"
    >
      <span class="modal__label">{{ $t('events.description') }}</span>
      <el-input @focus="inputFocus" border line v-model="newItem.comment" />
    </div>

    <div
      class="modal__input"
      :class="{ 'is-active': newItem.locations.length > 0 }"
      @click="modals.map = !modals.map"
    >
      <span class="modal__label">{{ $t('events.location') }}</span>
      <el-input @focus="inputFocus" border line v-model="newItem.locations" />
    </div>

    <!-- <div class="modal__input" :class="{ 'is-active': newItem.tags }">
      <span class="modal__label">Tags</span>
      <el-input
        v-model="inputValue"
        @keyup.enter.native="handleInputConfirm"
        @blur="handleInputConfirm"
        @focus="inputFocus"
        border
        line
      />
    </div> -->

    <!-- <el-tag
      :key="item.id"
      v-for="item in newItem.tags"
      :disable-transitions="false"
      closable
      effect="dark"
      @close="handleClose(item)"
    >
      <span>{{ item.tag }}</span>
    </el-tag> -->

    <div
      v-for="(item, index) in newItem.payment"
      :key="index"
      class="modal__grid"
    >
      <div v-if="user">
        <div class="modal__input">
          <span class="modal__label">{{ $t('events.payment') }}</span>
          <el-select @focus="inputFocus" border line v-model="item.type">
            <el-option
              v-for="item in user.payment_types"
              :key="item.id"
              :value="item.payment_type"
            >
              {{ item.payment_type }}
            </el-option>
          </el-select>
        </div>
      </div>
      <div>
        <div class="modal__input">
          <span class="modal__label">{{ $t('events.price') }}</span>
          <el-input v-model="item.value" @focus="inputFocus" border line />
        </div>
      </div>
    </div>

    <AddPayment
      v-if="newItem.payment.length !== user.payment_types.length"
      @click="useAddPayment(newItem.payment)"
    />

    <!-- <el-upload type="preview" /> -->

    <Button size="medium" @click="createAlbum">
      {{ $t('buttons.create') }}
      <svg-icon name="arrow-line" class="icon-radius" />
    </Button>

    <Map
      v-if="modals.map"
      :data="user.location"
      type="edit"
      @closeMap="modals.map = false"
      :onCreate="onCreateLocation"
    />
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  computed,
  useContext
} from '@nuxtjs/composition-api'

import { useCreateAlbumMutation, useCreateLocationMutation } from '~/sdk/hooks'
import useGenerateUUID from '@/hooks/generate-uuid'
import useAddPayment from '@/hooks/add-payment'

import elInput from '@/components/element/Input.vue'
import elSelect from '@/components/element/Select.vue'
import elDatePicker from '@/components/element/DatePicker.vue'
import elTimeSelect from '@/components/element/TimeSelect.vue'
import elUpload from '@/components/element/Upload.vue'
import elTag from '@/components/element/Tag.vue'

import AddPayment from '@/components/ui/AddPayment.vue'
import Button from '@/components/ui/Button.vue'
import Modal from '@/components/ui/Modal.vue'
import Map from '@/components/ui/Map.vue'

type Item = {
  id: string
  name: string
  comment: string
  locations: string
  payment: any
  tags: any
}

export default defineComponent({
  name: 'AlbumsPage',
  components: {
    Modal,
    Button,
    AddPayment,
    Map,
    elTag,
    elUpload,
    elInput,
    elSelect,
    elDatePicker,
    elTimeSelect
  },
  setup(_, { root }) {
    const user = computed(() => root.$accessor.auth.user)
    const inputFocus = (event: any) => {
      event.target.closest('.modal__input').classList.add('is-active')
    }
    if (!user.value) return

    const modals = ref({ map: false })
    const newItem = ref<Item>(createItem())
    function createItem(): Item {
      const object: Item = {
        id: useGenerateUUID(),
        name: '',
        comment: '',
        locations: '',
        tags: [],
        payment: [
          {
            type: '',
            value: undefined
          }
        ]
      }
      return object
    }

    // tags
    const inputValue = ref('')
    const handleClose = (tag: any) => {
      newItem.value.tags.splice(newItem.value.tags.indexOf(tag), 1)
    }

    const handleInputConfirm = () => {
      if (inputValue.value) {
        newItem.value.tags.push({
          tag: inputValue.value,
          id: useGenerateUUID(),
          moderated: false
        })
      }
      inputValue.value = ''
    }

    // map component

    const newLocation = ref()
    const newLocationGeo = ref(null)
    const onCreateLocation = (data: any) => {
      modals.value.map = false
      newItem.value.locations = data.location_name
      newLocation.value = data
      newLocationGeo.value = data.coordinates
    }

    const { mutate: createAlbumMutation } = useCreateAlbumMutation({})
    const { mutate: updateGeo } = useCreateLocationMutation({})
    async function createAlbum() {
      if (newLocation.value) {
        await updateGeo({
          object: {
            id: newLocation.value.id,
            ...newLocation.value.geo,
            geo: {
              type: 'Point',
              coordinates: newLocation.value.coordinates
            }
          }
        })
      }
      await createAlbumMutation({
        object: {
          id: newItem.value.id,
          name: newItem.value.name || undefined,
          comment: newItem.value.comment || undefined,
          location_id: newLocation.value.id || undefined
        },
        payment: newItem.value.payment.map((r: any) => ({
          album_id: newItem.value.id,
          payment_type: r.type,
          price: r.value >= 0 ? r.value : 0
        }))
      })
    }

    return {
      user,
      newItem,
      modals,
      createAlbum,
      inputFocus,

      newLocationGeo,
      onCreateLocation,

      useAddPayment,

      inputValue,
      handleClose,
      handleInputConfirm
    }
  }
})
</script>
